﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Repository
{
    public class LoggedRepository<T> : IRepository<T>
    {

        private void Log(string msg, object args = null)
        {
            Console.ForegroundColor=ConsoleColor.Red;
            Console.WriteLine(msg,args);
            Console.ResetColor();
        }

        public void Create(T entity)
        {
            Log("Décorateur - Avant Create {0}",entity);
            Console.WriteLine("Ajout de {0}", entity);
            Log("Décorateur - Après Create {0}", entity);
        }

        public void Update(T entity)
        {
            Log("Décorateur - Avant Update {0}", entity);
            Console.WriteLine("Mise à jour de {0}", entity);
            Log("Décorateur - Après Update {0}", entity);
        }

        public T Read(int id)
        {
            Log("Décorateur - Avant Read {0}", id);
            Console.WriteLine("Lecture entity ID = {0}", id);
            Log("Décorateur - Après Read {0}", id);
            return default(T);
        }

        public void Delete(T entity)
        {
            Log("Décorateur - Avant Delete {0}", entity);
            Console.WriteLine("Suppression de {0}", entity);
            Log("Décorateur - Après Delete {0}", entity);
        }

        public IEnumerable<T> SelectAll()
        {
            Log("Décorateur - Avant SelectAll");
            Console.WriteLine("Lister toutes les entités...");
            Log("Décorateur - Après SelectAll");
            return null;
        }
    }
}
